#!/usr/bin/perl

use File::Copy;
use Fcntl;

$GROUP_RPM       = "./MailWebServer_UpdateRPM.tgz";
$LOG_FILE        = "/var/log/patch01-12.log";
$FILELIST        = "./InstallFileList.txt";

# ѥå󥹥ȡɲýɬפʥѥå
$BIND_RPM        = "bind-9.2.4-41.i386.rpm";
$BIND_ENT        = "bind-9.2.4-41";
$BIND_CHROOT_RPM = "bind-chroot-9.2.4-41.i386.rpm";
#$SAMBA_COM_RPM   = "samba-common-3.0.33-3.36_MW.i386.rpm";

#$APACHE_RPM = "httpd-2.0.52-49.ent.i386.rpm";

# 󥹥ȡ뤹ѥå
#ʤ

print "\n---Script Start-----\n\n";
system("echo '---Script Start-----' >> $LOG_FILE");
system("/bin/date >> $LOG_FILE");

if(!-e $GROUP_RPM){
  print "No such file : $GROUP_RPM\n";
  system("echo 'No such file : $GROUP_RPM' >> $LOG_FILE");
  exit 1;
}
if(!open(IN,"/bin/tar -xzf $GROUP_RPM |")){
  print "$GROUP_RPM Decompression Failed.\n";
  system("echo '$GROUP_RPM Decompression Failed.' >> $LOG_FILE");
  exit 1;
}

close(IN);

@HB_fileP=();
if($ARGV[0] eq ""){
  &AllInstall();
}
elsif($ARGV[0] eq "-D"){
 if(-d "./wbmc_rpm"){
   system("/bin/rm -rf ./wbmc_rpm > /dev/null 2>&1");
   print "Delete Sccessful.(./wbmc_rpm)\n";
 }
}
else{
  print "Invalid Option.";
  system("echo 'Invalid Option' >> $LOG_FILE");
}

if(-d "./wbmc_rpm"){
  system("/bin/rm -rf ./wbmc_rpm > /dev/null 2>&1");
}

#my $status;
#$status = &inittabchange();

system("/bin/rpm -qa >> $LOG_FILE");
system("/bin/date >> $LOG_FILE");
print "\n---Script End-----\n";
system("echo '---Script End-----' >> $LOG_FILE");
#&Webalizerchange();
exit 0;


sub AllInstall
{
  local($rpmname) = "";
  local(@LS_fileP) = ();
  local(@code) = ();

  if(!-e $FILELIST){
    print "No such file : $FILELIST\n";
    system("echo 'No such file :$FILELIST' >> $LOG_FILE");
    return;
  }

  &readFile($FILELIST,*LS_fileP);

  foreach $rpmname (@LS_fileP){
    $rpmname =~ s/^\s*//;
    $rpmname =~ s/\s*$//;
	if(!-e "./wbmc_rpm/$rpmname"){
  	  print "No such file : $rpmname\n";
	  system("echo 'No such file : $rpmname' >> $LOG_FILE");
  	  return;
	}
  }

  foreach $rpmname (@LS_fileP){
    $rpmname =~ s/^\s*//;
    $rpmname =~ s/\s*$//;
    
    if($rpmname eq "$APACHE_RPM"){
       &ApacheInstall($rpmname);

       if(-e "/etc/httpd/conf/httpd.conf.rpmnew"){
         system("/bin/rm /etc/httpd/conf/httpd.conf.rpmnew > /dev/null 2>&1");
       }
    }
    elsif($rpmname eq "$APACHE_S_RPM"){
      if(!open(IN,"/bin/rpm -qq $HTTP_ENT 2>&1 |")){
        print "Error Update.($rpmname)\n";
        system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
        return;
      }
      @code = ();
      @code = <IN>;
      close(IN);

      if($code[0] =~ /package\s+(.+)\s+is\s+not\s+installed/){
        print "Error Update.($rpmname)\n";
        system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
        return;
      }

      UpdateRPM($rpmname);
      system("/bin/chmod u-s /usr/sbin/suexec &> /dev/null");
    }
    elsif($rpmname eq "$MODSSL_RPM"){
      $APACHE_RPM =~ /(.*)\..*\.rpm$/ ;
      $APACHE_VER = $1;
      if(!open(IN,"/bin/rpm -qq $APACHE_VER 2>&1 |")){
        print "Error Update.($rpmname)\n";
        system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
        next;
      }
      close(IN);
      UpdateRPM($rpmname);
    }
    elsif($rpmname eq "$BIND_RPM"){
      UpdateRPM($rpmname);

      if(-e "/etc/rndc.key.rpmnew"){
        system("/bin/rm /etc/rndc.key.rpmnew > /dev/null 2>&1");
      }

      system("/bin/chmod 770 /var/named > /dev/null 2>&1");
    }
    elsif($rpmname eq "$BIND_CHROOT_RPM"){
      if(!open(IN,"/bin/rpm -qq $BIND_ENT 2>&1 |")){
        print "Error Update.($rpmname)\n";
        system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
        return;
      }
      @code = ();
      @code = <IN>;
      close(IN);

      if($code[0] =~ /package\s+(.+)\s+is\s+not\s+installed/){
        print "Error Update.($rpmname)\n";
        system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
        return;
      }

      UpdateRPM($rpmname);

      if(-e "/etc/named.conf.rpmsave"){
        system("/bin/rm /etc/named.conf.rpmsave > /dev/null 2>&1");
      }

      if(-e "/var/named/chroot/etc/named.conf.rpmsave"){
        system("/bin/rm /var/named/chroot/etc/named.conf.rpmsave > /dev/null 2>&1");
      }

      system("/bin/chown -f --from=root:named named:named /var/named/chroot/var/named > /dev/null 2>&1");
      system("/bin/chmod 770 /var/named/chroot/var/named > /dev/null 2>&1");
    }
    elsif($rpmname eq "$LIBGL_RPM"){
      InstallRPM($rpmname);
    }
    elsif($rpmname eq "$LIBS_RPM"){
      InstallRPM($rpmname);
    }
    elsif($rpmname eq "$OPENLDAP_S_RPM"){
      if(!open(IN,"/bin/rpm -qq $OPENLDAP_ENT 2>&1 |")){
        print "Error Update.($rpmname)\n";
        system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
        return;
      }
      @code = ();
      @code = <IN>;
      close(IN);

      if($code[0] =~ /package\s+(.+)\s+is\s+not\s+installed/){
        print "Error Update.($rpmname)\n";
        system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
        return;
      }

      &OpenldapServerInstall($rpmname);

      if(-e "/etc/openldap/slapd.conf.rpmnew"){
        system("/bin/rm /etc/openldap/slapd.conf.rpmnew > /dev/null 2>&1");
      }
    }
    elsif($rpmname eq "$SAMBA_COM_RPM"){
      if(!open(IN,"/bin/rpm -qq $SAMBA_ENT 2>&1 |")){
        print "Error Update.($rpmname)\n";
        system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
        return;
      }
      @code = ();
      @code = <IN>;
      close(IN);

      if($code[0] =~ /package\s+(.+)\s+is\s+not\s+installed/){
        print "Error Update.($rpmname)\n";
        system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
        return;
      }

      UpdateRPM($rpmname);

      if(-e "/etc/samba/smb.conf.rpmnew"){
        system("/bin/rm /etc/samba/smb.conf.rpmnew > /dev/null 2>&1");
      }
    }
    elsif($rpmname eq "$SYSINIT_RPM"){
      if(UpdateRPM($rpmname) == 0){
        if(-e "/etc/rc.d/rc.sysinit.rpmsave"){
          system("/bin/rm /etc/rc.d/rc.sysinit.rpmsave > /dev/null 2>&1");
        }
      }
    }
    elsif($rpmname eq "$BOND0"){
      	  &replace($rpmname);
    }
    else{
      UpdateRPM($rpmname);
    }
  }
}

sub UpdateRPM
{
  local($rpmname) = @_;
  local($shortname) = "";
  local(@code) = ();

  $shortname=Judge_RPM($rpmname);

  if(!open(IN,"LANG= /bin/rpm -qq $shortname 2>&1 |")){
    print "Update Failed.($rpmname)\n";
    system("echo 'Update Failed.($rpmname)' >> $LOG_FILE");
    return 1;
  }
  @code = <IN>;
  close(IN);

#  if($code[0] =~ /package\s+(.+)\s+is\s+not\s+installed/){
#    print "Package $rpmname is not installed.\n";
#    return 0;
#  }

  if(!open(IN,"/bin/rpm -U --nodeps --force ./wbmc_rpm/$rpmname > /dev/null 2>&1 |")){
    print "Update Failed.($rpmname)\n";
    system("echo 'Update Failed.($rpmname)' >> $LOG_FILE");
    return 1;
  }
  close(IN);

  print "Update Successful.($rpmname)\n";
  system("echo 'Update Successful.($rpmname)' >> $LOG_FILE");
  return 0;
}

sub InstallRPM
{
  local($rpmname) = @_;
  if(!open(IN,"/bin/rpm -i --nodeps ./wbmc_rpm/$rpmname > /dev/null 2>&1 |")){
    print "Install Failed.($rpmname)\n";
    system("echo 'Install Failed.($rpmname)' >> $LOG_FILE");
    return 1;
  }
  close(IN);
  print "Install Successful.($rpmname)\n";
  system("echo 'Install Successful.($rpmname)' >> $LOG_FILE");
  return 0;
}

sub ApacheInstall
{
  local($rpmname) = @_;
  local($i,$j) = "";
  local(@HC_fileP,@RA_fileP,@HC_fileP,@code) = ();

  $HTTPDCONF      = "/etc/httpd/conf/httpd.conf";
  $ROTATE_APACHE  = "/etc/logrotate.d/apache";
  $ROTATE_HTTPD   = "/etc/logrotate.d/httpd";

  if(!-e $HTTPDCONF){
    print "No such file : $HTTPDCONF\n";
    system("echo 'No such file :$HTTPDCONF' >> $LOG_FILE");
  }

	##==========================
	## ReadFile : $HTTPDCONF
	##==========================
	@HC_fileP=();
	&readFile($HTTPDCONF,*HC_fileP);

	foreach(@HC_fileP){
	  if(/^\s*\#/){
	    next;
	  }
	  elsif(/^\s*Timeout\s+(.+)\s+$/i){
	    $key{'TIMEOUT'}  = $1;
	  }
	  elsif(/^\s*MinSpareServers\s+(.+)\s+$/i){
	    $key{'MINSPARE'} = $1;
	  }
	  elsif(/^\s*MaxSpareServers\s+(.+)\s+$/i){
	    $key{'MAXSPARE'} = $1;
	  }
	  elsif(/^\s*StartServers\s+(.+)\s+$/i){
	    $key{'STARTS'} = $1;
	  }
	  elsif(/^\s*MaxClients\s+(.+)\s+$/i){
	    $key{'MAXCL'} = $1;
	  }
	  elsif(/^\s*User\s+(.+)\s+$/i){
	    $key{'USER'} = $1;
	  }
	  elsif(/^\s*Group\s+(.+)\s+$/i){
	    $key{'GROUP'} = $1;
	  }
	  elsif(/^\s*ServerName\s+(.+)\s+$/i){
	    $key{'SVNAME'} = $1;
	  }
	  elsif(/^\s*ServerAdmin\s+(.+)\s+$/i){
	    $key{'SVADMIN'} = $1;
	  }
	  elsif(/^\s*Include\s+(.+)\s+$/i){
	    push(@inc,"Include $1\n");
	  }
	  elsif(/^\s*Port\s+(.+)\s+$/i){
	    $key{'PORT'} = $1;
	  }
	  elsif(/^\s*ServerTokens\s+(.+)\s+$/i){
	    $key{'ServerTokens'} = $1;
	  }
	}
#	if(!$key{"SVADMIN"}){
#	  $key{"SVADMIN"} = "web@".$key{"SVNAME"};
#	}

	##========================
	## Read : $ROTATE_APACHE
	##========================
	@RA_fileP=();
	&readFile($ROTATE_APACHE,*RA_fileP);

	##====================
	## Update : Apache
	##====================
	if(!open(IN,"/bin/rpm -qq $HTTP_ENT 2>&1 |")){
	  print "Error Update.($rpmname)\n";
	  system("echo 'Error Update.($rpmname)' >> $LOG_FILE");
	  return;
	}
	@code = ();
	@code = <IN>;
	close(IN);

#	if($code[0] !~ /package\s+(.+)\s+is\s+not\s+installed/){
#	  print "Package $rpmname is already installed\n";
#	  return;
#	}
	if(!open(IN,"/bin/rpm -U --nodeps --force ./wbmc_rpm/$rpmname > /dev/null 2>&1 |")){
	#    print "Failed to Update.($rpmname)\n";
	    system("echo 'Update Failed.($rpmname)' >> $LOG_FILE");
	    return;
	}
	close(IN);

#	system("/bin/chmod u-s /usr/sbin/suexec &> /dev/null");

	##================================
	## Substitution : $ROTATE_APACHE
	##================================
# 2006/3/20 Խɬפʤ
# httpd-2.0.46-46.3.entΥåץǡȤǤ/etc/logrotate.d/apache
# ѹƤʤλͤȤƥϻĤƤޤ
#	&writeFile($ROTATE_APACHE,*RA_fileP);
#	if(-e "$ROTATE_APACHE".".rpmsave"){
#	  system("/bin/rm -rf $ROTATE_APACHE".".rpmsave");
#	}
# logrotate RHEL3 ɸ : /etc/logrotate.d/httpd,
# logrotate MW ɸ    : /etc/logrotate.d/apache
# ξ¸ߤȥơȴֳ֤Τ httpd 
	if(-e '/etc/logrotate.d/httpd') {
		unlink('/etc/logrotate.d/httpd');
	}

	##============================
	## Substitution : $HTTPDCONF
	##============================
	@HC_fileP=();
	&readFile($HTTPDCONF,*HC_fileP);

	for($i=0;$i<@HC_fileP;$i++){
	  if($HC_fileP[$i] =~ /^\s*\#/){
	    next;
	  }
	  elsif($HC_fileP[$i] =~ /^\s*Timeout\s+/i){
	    splice(@HC_fileP,$i,1,"Timeout $key{'TIMEOUT'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*MinSpareServers\s+/i){
	    splice(@HC_fileP,$i,1,"MinSpareServers $key{'MINSPARE'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*MaxSpareServers\s+/i){
	    splice(@HC_fileP,$i,1,"MaxSpareServers $key{'MAXSPARE'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*StartServers\s+/i){
	    splice(@HC_fileP,$i,1,"StartServers $key{'STARTS'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*MaxClients\s+/i){
	    splice(@HC_fileP,$i,1,"MaxClients $key{'MAXCL'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*User\s+/i){
	    splice(@HC_fileP,$i,1,"User $key{'USER'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*Group\s+/i){
	    splice(@HC_fileP,$i,1,"Group $key{'GROUP'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*ServerName\s+/i){
	    splice(@HC_fileP,$i,1,"ServerName $key{'SVNAME'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*ServerAdmin\s+/i){
	    splice(@HC_fileP,$i,1,"ServerAdmin $key{'SVADMIN'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^Listen\s*80\s+/i){
	    splice(@HC_fileP,$i,1,"#Listen 80\n");
	  }
	  elsif($HC_fileP[$i] =~ /^Listen\s*443\s+/i){
	    splice(@HC_fileP,$i,1,"#Listen 443\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*Port\s+/i){
	    splice(@HC_fileP,$i,1,"Port $key{'PORT'}\n");
	  }
	  elsif($HC_fileP[$i] =~ /^\s*ServerTokens\s+/i){
	    if($key{'ServerTokens'} =~ /OS/){
		splice(@HC_fileP,$i,1,"ServerTokens ProductOnly\n");
	    }
	    else{
		splice(@HC_fileP,$i,1,"ServerTokens $key{'ServerTokens'}\n");
	    }
	  }
	  elsif($HC_fileP[$i] =~ /^\s*DocumentRoot\s+\"*\/home\/httpd\/html\"*/i) {
		$HC_fileP[$i] = "DocumentRoot \"/home/web/public_html\"\n";
	  }
	  elsif ($HC_fileP[$i] =~ /^\s*<\s*Directory\s+\"*\/home\/httpd\/html\"*\s*>/i) {
	    $HC_fileP[$i] = "<Directory \"/home/web/public_html\">\n";
	  }

	  elsif($HC_fileP[$i] =~ /^\s*Include\s+(.+)\s+$/i){
        for($j=0;$j<@inc;$j++){
		  if($HC_fileP[$i] eq $inc[$j]){
    	    splice(@inc,$j,1);
		    $j--;
		  }
		}
	  }

	}
	push(@HC_fileP,@inc);
	&writeFile($HTTPDCONF,*HC_fileP);
	print "httpd_Update Successful.($rpmname)\n";
	system("echo 'httpd_Update Successful.($rpmname)' >> $LOG_FILE");

	return;
}

sub OpenldapServerInstall
{
  local($rpmname) = @_;
  local($i) = "";
  local(@HC_fileP,@HC_fileP,@code) = ();

  $SLAPDCONF      = "/etc/openldap/slapd.conf";
  $PIDWORD        = "/var/run/slapd.pid";
  $NEWPIDWORD     = "/var/run/openldap/slapd.pid";
  $ARGSWORD       = "/var/run/slapd.args";
  $NEWARGSWORD    = "/var/run/openldap/slapd.args";

  if(!-e $SLAPDCONF){
    print "No such file : $SLAPDCONF\n";
    system("echo 'No such file :$SLAPDCONF' >> $LOG_FILE");
  }

	##==========================
	## ReadFile : $SLAPDCONF
	##==========================
	@HC_fileP=();
	&readFile($SLAPDCONF,*HC_fileP);

	foreach(@HC_fileP){
	  if(/^\s*\#/){
	    next;
	  }
	  elsif(/^\s*pidfile\s+(.+)\s+$/i){
	    $key{'PIDFILE'}  = $1;
	  }
	  elsif(/^\s*argsfile\s+(.+)\s+$/i){
	    $key{'ARGSFILE'} = $1;
	  }
	}

	##====================
	## Update : openldap-servers
	##====================
	if(!open(IN,"/bin/rpm -U --nodeps --force ./wbmc_rpm/$rpmname > /dev/null 2>&1 |")){
	    system("echo 'Update Failed.($rpmname)' >> $LOG_FILE");
	    return;
	}

	close(IN);

	##============================
	## Substitution : $SLAPDCONF
	##============================

	@HC_fileP=();
	&readFile($SLAPDCONF,*HC_fileP);

	for($i=0;$i<@HC_fileP;$i++){
	  if($HC_fileP[$i] =~ /^\s*\#/){
	    next;
	  }
	  elsif($HC_fileP[$i] =~ /^\s*pidfile\s+/i){
	    if($key{'PIDFILE'} =~ /$PIDWORD/){
		splice(@HC_fileP,$i,1,"pidfile $NEWPIDWORD\n");
	    }
	    else{
		splice(@HC_fileP,$i,1,"pidfile $key{'PIDFILE'}\n");
	    }
	  }
	  elsif($HC_fileP[$i] =~ /^\s*argsfile\s+/i){
	    if($key{'ARGSFILE'} =~ /$ARGSWORD/){
		splice(@HC_fileP,$i,1,"argsfile $NEWARGSWORD\n");
	    }
	    else{
		splice(@HC_fileP,$i,1,"argsfile $key{'ARGSFILE'}\n");
	    }
	  }
	}

	push(@HC_fileP);
	&writeFile($SLAPDCONF,*HC_fileP);
	print "Update Successful.($rpmname)\n";
	system("echo 'Update Successful.($rpmname)' >> $LOG_FILE");

	return;
}

sub Judge_RPM
{
  local($rpmname) = @_;
  local(@code) = ();

  if(!open(IN,"/bin/rpm -qip ./wbmc_rpm/$rpmname |")){
    print "Existence check failed.($rpmname)\n";
    system("echo 'Existence check failed.($rpmname)' >> $LOG_FILE");
    return "";
  }
  @code=<IN>;
  @ent = split(/\s+/,$code[0]);
  return ($ent[2]);

}

sub readFile
{
  local($filename,*fileP) = @_;

  if(open(IN,"$filename")){
    @fileP = <IN>;
    close (IN);
  }

}

sub writeFile
{
  local($filename,*fileP) = @_;

  if(open(OUT,"> $filename")){
    print(OUT @fileP);
    close(OUT);
  }
}

sub Webalizerchange{

	my $LOGFILE  = "/var/log/webalizerconf.change";
	my $filename = "/etc/webalizer.conf";
	my $la;
	my @las;
	my $redocount = 3;

	system("/bin/touch /var/log/webalizerconf.change > /dev/null 2>&1");
	print "\n---Webalizer conf changer Start-----\n\n";
	system("echo '---Webalizer conf changer Start-----' >> $LOGFILE");
	system("/bin/date >> $LOGFILE");
	eval 
	{
		local $SIG{ALRM} = sub { die "time out\n" };
		alarm(60);
		open(IN, "< $filename") or die "Can't open $filename: $!\n";
		flock(IN,1) or die "Can't lock $filename:$!\n";
		seek(IN,0,0);
# Webalizer setting is changed as follows.
#----------------------------------------------------------------------
#       #HistoryName   /var/lib/webalizer/webalizer.hist
#       Incremental yes
#       #IncrementalName        /var/lib/webalizer/webalizer.current 
#-----------------------------------------------------------------------
		my $inclflag = 0;
		my $pattern 	= "^HistoryName\\s+";
		my $pattern1    = "^[#|\\s]+\\s*Incremental\\s+(|yes|no){1}?\\s*\$";
		my $pattern1_1 	= "^Incremental\\s+(|yes|no){1}?\\s*\$";
		my $pattern2 	= "^IncrementalName\\s+";

		while($la = <IN>){
			if ($la =~ /$pattern/) {
				$la = "#".$la;
			}
			if( $la =~ /$pattern1/ || $la =~ /$pattern1_1/) 
			{
				if ($inclflag == 1 && $la =~ /$pattern1_1/)
				{
					$la = "#".$la;
				}
				if ($inclflag == 0)
				{
					$la = "Incremental yes\n";
					$inclflag = 1;
				}
			}
			if($la =~ /$pattern2/) {
				$la = "#".$la;
			}
			push(@las,$la);
		}
		if ($inclflag == 0)
		{
			push(@las,"Incremental yes\n");
		}
		flock(IN,8);
		close(IN);
	};
	if ($@) {
		my $lg = $@;
		system("echo \"ERROR! $lg\" >> $LOGFILE");
		print "ERROR! $lg\n";
		system("/bin/date >> $LOGFILE");
		print "\n---Webalizer conf changer End-----\n";
		system("echo '---Webalizer conf changer End-----' >> $LOGFILE");
		alarm(0);
		return 1;
	}
	else{
#        normail write
TRY: {
	     eval{
		     local $SIG{ALRM} = sub { die "time out\n" };
		     alarm(60);
		     open(WR,"> $filename") || die "Can't open $filename:$!\n";
		     flock(WR,2) or die "Can't flock $filename";
		     seek(WR,0,0);
		     print(WR  @las);
		     flock(WR,8);
		     close(WR);
	     };
	     if($@){
		     my $error = $@;
		     /Can't flock/      ? do {
			     die unless (--$redocount);
			     sleep 1;
			     redo TRY;
		     }:
		     /Can't open/       ? do {
			     die unless (--$redocount);
			     sleep 1;
			     redo TRY;
		     }:
		     system("echo \"ERROR! $error\" >> $LOGFILE");
		     print "ERROR! $error\n";
		     system("/bin/date >> $LOGFILE");
		     print "\n---Webalizer conf changer End-----\n";
		     system("echo '---Webalizer conf changer End-----' >> $LOGFILE");
		     alarm(0);
		     return 1;
	     }
     }
	};

	print "SUCCESS! update of /etc/webalizer.conf\n";
	system("echo 'SUCCESS! update of /etc/webalizer.conf' >> $LOGFILE");
	system("/bin/date >> $LOGFILE");
	print "\n---Webalizer conf changer End-----\n";
	system("echo '---Webalizer conf changer End-----' >> $LOGFILE");
	alarm(0);
	return 0;
}

sub inittabchange{

	my $LOGFILE  = "/var/log/inittab.change";
	my $filename = "/etc/inittab";
	my $la;
	my @las;
	my $redocount = 3;

	system("/bin/touch /var/log/inittab.change > /dev/null 2>&1");
	print "\n---inittab conf changer Start-----\n\n";
	system("echo '---inittab conf changer Start-----' >> $LOGFILE");
	system("/bin/date >> $LOGFILE");
	eval 
	{
		local $SIG{ALRM} = sub { die "time out\n" };
		alarm(60);
		open(IN, "< $filename") or die "Can't open $filename: $!\n";
		flock(IN,1) or die "Can't lock $filename:$!\n";
		seek(IN,0,0);
		my $pattern 	= "^s0\:";
		while($la = <IN>){
			if ($la =~ /$pattern/) {
				$la = "#".$la;
			}
			push(@las,$la);
		}
		flock(IN,8);
		close(IN);
	};
	if ($@) {
		my $lg = $@;
		system("echo \"ERROR! $lg\" >> $LOGFILE");
		print "ERROR! $lg\n";
		system("/bin/date >> $LOGFILE");
		print "\n---inittab conf changer End-----\n";
		system("echo '---inittab conf changer End-----' >> $LOGFILE");
		alarm(0);
		return 1;
	}
	else{
#        normail write
TRY: {
	     eval{
		     local $SIG{ALRM} = sub { die "time out\n" };
		     alarm(60);
		     open(WR,"> $filename") || die "Can't open $filename:$!\n";
		     flock(WR,2) or die "Can't flock $filename";
		     seek(WR,0,0);
		     print(WR  @las);
		     flock(WR,8);
		     close(WR);
	     };
	     if($@){
		     my $error = $@;
		     /Can't flock/      ? do {
			     die unless (--$redocount);
			     sleep 1;
			     redo TRY;
		     }:
		     /Can't open/       ? do {
			     die unless (--$redocount);
			     sleep 1;
			     redo TRY;
		     }:
		     system("echo \"ERROR! $error\" >> $LOGFILE");
		     print "ERROR! $error\n";
		     system("/bin/date >> $LOGFILE");
		     print "\n---inittab conf changer End-----\n";
		     system("echo '---inittab conf changer End-----' >> $LOGFILE");
		     alarm(0);
		     return 1;
	     }
     }
	};

	print "SUCCESS! update of /etc/inittab\n";
	system("echo 'SUCCESS! update of /etc/inittab' >> $LOGFILE");
	
	system("/bin/date >> $LOGFILE");
	print "\n---inittab conf changer End-----\n";
	system("echo '---inittab conf changer End-----' >> $LOGFILE");
	alarm(0);
	return 0;
}
sub replace {
		local($replacename) = @_;
		$LOGFILE = "/var/log/ifcfg-bond0.change";
		$dstdirectory = "/etc/sysconfig/network-scripts";
		
		if(!move("./wbmc_rpm/$replacename","$dstdirectory\/$replacename"))
		{
			print "$replacename file move failed";
			system("echo '$replacename file move failed' >> $LOGFILE");
			return 1;
		}
		print "\nSUCCESS! File add $replacename\n";
		system("echo 'SUCCESS! File add $replacename' >> $LOGFILE");
		return 0;
		
}

